#version 420

layout (location = 0) in vec4 Position;
layout (location = 1) in vec4 Velocity;

uniform mat4 ModelViewMatrix;

out vData
{
	float TTL1;
	vec3 ParticleColor1;
} vertex;

vec3 hueToRGB(float hue)
{
	vec3 color = vec3(0.5);
	float hValue = mod(hue, 1.0) / 2.0f;

	if (hue < 1.0f)
		color = vec3(1.0f, 0.5f + hValue, 0.5f);
	else if (hue < 2.0f)
		color = vec3(1.0f - hValue, 1.0f, 0.5f);
	else if (hue < 3.0f)
		color = vec3(0.5f, 1.0f, 0.5f + hValue);
	else if (hue < 4.0f)
		color = vec3(0.5f, 1.0f - hValue, 1.0f);
	else if (hue < 5.0f)
		color = vec3(0.5f + hValue, 0.5f, 1.0f);
	else if (hue < 6.0f)
		color = vec3(1.0f, 1.0f - hValue, 0.5f);

	return color;
}

void main()
{
	gl_Position = ModelViewMatrix * vec4(Position.xyz, 1.0f);
	vertex.TTL1 = Position.w;
	vertex.ParticleColor1 = hueToRGB(Velocity.w);
}