#version 430 core
layout (location = 0) in vec3 pos;
layout (location = 1) in vec3 vertNormal;
layout (location = 2) in vec2 tex;

uniform mat4 model = mat4(1.0);
uniform mat4 view = mat4(1.0);
uniform mat4 projection = mat4(1.0);
uniform mat4 lightSpaceMatrix = mat4(1.0);

out vec2 vertexTexCoord;
out vec4 FragPosition;
out vec4 FragPositionLightSpace;
out vec3 Normal;

void main()
{
	FragPosition = model * vec4(pos, 1.0);
	FragPositionLightSpace = lightSpaceMatrix * FragPosition;
	gl_Position = projection * view * FragPosition;
	vertexTexCoord = tex;
	Normal = mat3(transpose(inverse(model))) * vertNormal;
}
