#version 430 core
layout (location = 0) in vec3 pos;
layout (location = 1) in vec3 col;
layout (location = 2) in vec2 tex;

uniform mat4 model = mat4(1.0);
uniform mat4 view = mat4(1.0);
uniform mat4 projection = mat4(1.0);

out vec4 vertexColor;
out vec2 vertexTexCoord;

void main()
{
	gl_Position = projection * view * model * vec4(pos, 1.0);
	vertexColor = vec4(col.r, col.g, col.b, 1.0);
	vertexTexCoord = tex;
}
